Solution to Count-Non-Divisible by codility | Code Says


Solution to Count-Non-Divisible by codility | Code Says
You are given a non-empty zero-indexed array A consisting of N integers.
For each number A[i] such that 0 ≤ i < N, we want to count the number of elements of the array that are not the divisors of A[i]. We say that these elements are non-divisors.
For example, consider integer N = 5 and array A such that:
    A[0] = 3
    A[1] = 1
    A[2] = 2
    A[3] = 3
    A[4] = 6
For the following elements:
  • A[0] = 3, the non-divisors are: 2, 6,
  • A[1] = 1, the non-divisors are: 3, 2, 3, 6,
  • A[2] = 2, the non-divisors are: 3, 3, 6,
  • A[3] = 3, the non-divisors are: 2, 6,
  • A[6] = 6, there aren't any non-divisors.
Assume that the following declarations are given:
struct Results {
  int * C;
  int L;
};
Write a function:
struct Results solution(int A[], int N);
that, given a non-empty zero-indexed array A consisting of N integers, returns a sequence of integers representing the amount of non-divisors.
For example, given:
    A[0] = 3
    A[1] = 1
    A[2] = 2
    A[3] = 3
    A[4] = 6
the function should return [2, 4, 3, 2, 0], as explained above.
Assume that:
  • N is an integer within the range [1..50,000];
  • each element of array A is an integer within the range [1..2 * N].
http://www.martinkysel.com/codility-countnondivisible-solution/
Using the Sieve of Eratosthenes, you generate divisors for all input elements of A. If a given number x is a divisor of element (x*N == element), then N also is a divisor. (N = element//x). After all divisors are computed, we simply subtract those (multiplied by their counts or 0) from the total number of elements in A.
def solution(A):
  
    A_max = max(A)
  
    count = {}
    for element in A:
        if element not in count:
            count[element] = 1
        else:
            count[element] += 1
  
    divisors = {}
    for element in A:
        divisors[element] = set([1, element])
  
    # start the Sieve of Eratosthenes
    divisor = 2
    while divisor*divisor <= A_max:
        element_candidate = divisor
        while element_candidate  <= A_max:
            if element_candidate in divisors and not divisor in divisors[element_candidate]:
                divisors[element_candidate].add(divisor)
                divisors[element_candidate].add(element_candidate//divisor)
            element_candidate += divisor
        divisor += 1
  
    result = [0] * len(A)
    for idx, element in enumerate(A):
        result[idx] = (len(A)-sum([count.get(divisor,0) for divisor in divisors[element]]))
  
    return result
http://blog.csdn.net/liushuying668/article/details/38302693
1.首先定义一个vector counts来记录A中每个元素出现的次数
2.对任意一个i,计算A中A[i]的因子数。由于我们只需要计算小于或等于sqrt(A[i])的因子便可得出A[i]的所有因子,故外层循环:i,0~N-1
内层循环:j,1~sqrt(A[i])。若A[i] % j = 0则 j 是A[i]的因子,A[i]的因子数+1,若 j 不等于sqrt(A[i]),则A[i] / j 也是A[i]的因子,A[i]的因子数继续 +1。
3.最后,对每个i,res[i]等于N减去A[i]的因子数。
vector<int> solution(vector<int> &A) {
// write your code in C++11
int N = A.size();
vector<int>::iterator max = max_element(A.begin(),A.end());
vector<int> counts(*max+1,0);
for(int i = 0 ; i < N ; ++i)
{
counts[A[i]]++;
}
vector<int> res(N,0);
for(int i = 0 ; i < N ; ++i)
{
int divisors = 0;
for(int j = 1 ; j*j <= A[i] ; ++j)
{
if(A[i] % j == 0)
{
divisors += counts[j];
if(A[i]/j != j)
{
divisors += counts[A[i]/j];
}
}
}
res[i] = N - divisors;
}
return res;
}
http://www.bubuko.com/infodetail-514634.html
我们可以用2 * N的空间统计数组A中每个数出现多少次。我们在用一张表tab[1..2 * N],tab[i]记录数组A中出现的i的非约数有几个。起初我们认为tab[i] =  N,即A中所有的数都不是i的约数。然后对于每个A中出现的数,类似筛法,我们求它所有的倍数j,从tab[j]中减掉i在A中出现的次数,因为i是j的约数。时间复杂度主要在筛法那里 是O(2Nlog(2N)) = O(NlogN)。空间复杂度主要是两张表,一张统计数在A出现多少次,一张是tab,因为数据范围是2 * N,所以这个空间还是O(N)的。
vector<int> solution(vector<int> &A) {
    int n = A.size(), m = (n << 1) | 1;
    vector<int> num;
    num.resize(m + 1, 0);
    for (int i = 0; i < n; ++i) {
        ++num[A[i]];
    }
    vector<int> answer;
    answer.resize(m + 1, n);
    for (int i = 1; i <= m; ++i) {
        if (num[i]) {
            for (int j = i; j <= m; j += i) {
                answer[j] -= num[i];
            }
        }
    }
    vector<int> r;
    for (int i = 0; i < n; ++i) {
        r.push_back(answer[A[i]]);
    }
    return r;
}
http://codility-lessons.blogspot.com/2015/03/lesson-9-countnondivisible.html
The simplest solution is to check the occurrences of each value first, and then when we we given a number A[i], we check the divisors of A[i], which will be between 1 and sqrt(A[i]).  We count the total number of the occurrences of all the divisors (and the answers for (A[i] / divisor) ) and and subtract it from N.

This solution gives the 100% score.

However, the time complexity of the part to check a number between 1 and sqrt(A[i]) is O(sqrt(N)) , so this is indeed O(N * sqrt(N)), while the problem requires a O(N * log(N) ) solution. 
The O(N * sqrt(N)) solution
struct Results solution(int A[], int N) 
{
    //the number that may appear will be [1 ... 2 * N].
    int size = sizeof(int) * (N * 2 + 1);    
    int* occurrence = (int*)alloca(size);
    memset(occurrence, 0x00, size);
        
    
    //allocate the memory for the result.
    struct Results result;
    result.C = (int*)calloc(N, sizeof(int));
    result.L = N;
        
    //now we check the array A and count the occurance for each number.
    int i,j;
    for (i = 0; i < N; i++){
        occurrence[A[i]]++;
    }
          
    //now we compute the answer.
    for (i = 0; i < N; i++){
        int num = A[i];

        int div_cnt = 0;
        
        //count the number of the divisor while doing factorization.
        for (j = 1; j * j < num; j++){
            if (num % j == 0){
                div_cnt += occurrence[j];
                div_cnt += occurrence[num / j];
            }
        };
        
        if (j * j == num){
            div_cnt += occurrence[j];
        }
        
        result.C[i] = N - div_cnt;
    }
    
    return result;
}
The O(N * log(N)) solution 
struct Results solution(int A[], int N) 
{
    //the number that may appear will be [1 ... 2 * N].
    int size = sizeof(int) * (N * 2 + 1);    
    int* occurrence = (int*)alloca(size);
    memset(occurrence, 0x00, size);
    
    //the space to hold the answer for each value from 1 ... 2 * N.
    //for now we initialize it 
    int* answer = (int*)alloca(size);
    memset(answer, 0x00, size);
    
    
    //allocate the memory for the result.
    struct Results result;
    result.C = (int*)calloc(N, sizeof(int));
    result.L = N;
        
    //now we check the array A and count the occurance for each number.
    int i;
    for (i = 0; i < N; i++){
        occurrence[A[i]]++;
    }
        
    //now we compute the answer.
    for (i = 1; i <= N * 2; i++){
        int num = occurrence[i];
        
        //the number doesn't in the array A, we can neglect it.
        if (num == 0){
            continue;
        }

        //if it appears in the array A, 
        //subtract its counts from cells at itss multiples in the answer array.
        int j;
        for (j = i; j <= N * 2; j += i){
            answer[j] -= num;
        }        
    }
    
    //as the answer array contains the offset to N, 
    //N + answer[A[i]] will give the answer for each.
    for (i = 0; i < N; i++){
        result.C[i] = N + answer[A[i]];
    }
    
    return result;
}
http://codesays.com/2014/solution-to-count-non-divisible-by-codility/
Read full article from Solution to Count-Non-Divisible by codility | Code Says

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts